package ch.std.blog.random.test;

import static org.junit.jupiter.api.Assertions.assertEquals;
import static org.mockito.ArgumentMatchers.anyInt;
import static org.mockito.Mockito.when;

import java.util.Arrays;

import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.Mock;
import org.mockito.junit.jupiter.MockitoExtension;

import ch.std.blog.random.IRandom;
import ch.std.blog.random.RandomDoubleData;

@ExtendWith(MockitoExtension.class)
public class MockRandomDoubleUnitTest {

	@Mock
	private IRandom<Double> mockRandom;

	@Test
	public void testDoubleMockRandom() {

		System.out.println("mockRandom = " + this.mockRandom);
		when(mockRandom.newRandom(anyInt(), anyInt(), anyInt())).thenReturn(Arrays.asList(1.0, 2.0, 3.0));
		RandomDoubleData rdd = new RandomDoubleData(mockRandom);
		double expectedMin = 1.0;
		double expectedMax = 3.0;
		double expectedAverage = 2.0;

		assertEquals(expectedMin, rdd.getMin(), 0.001);
		assertEquals(expectedMax, rdd.getMax(), 0.001);
		assertEquals(expectedAverage, rdd.getAverage(), 0.001);

	}

}
